//---------------------------------------------------------------------------
#include <stdio.h>
#include <string.h>

#include "common.h"
//---------------------------------------------------------------------------
// mover pre mod 1
BYTE m1[22] = {
  0x21, 0x00, 0x00, 0x11, 0x00, 0x00, 0x01, 0x4F,
  0x00, 0xD5, 0xED, 0xB0, 0x21, 0x00, 0x00, 0x11,
  0x00, 0x00, 0x01, 0x00, 0x00, 0xC9
};
// depack rutina pre mod 1
BYTE r1[79] = {
  0xED, 0xB8, 0xEB, 0x11, 0x00, 0x00, 0x23, 0x7E,
  0xCB, 0x7F, 0x20, 0x15, 0xE6, 0x0F, 0x47, 0xED,
  0x6F, 0xC6, 0x03, 0x4F, 0x23, 0x7B, 0x96, 0x23,
  0xE5, 0x6F, 0x7A, 0x98, 0x67, 0x06, 0x00, 0x18,
  0x22, 0x23, 0xE6, 0x7F, 0x28, 0x0F, 0xCB, 0x77,
  0x20, 0x05, 0x4F, 0xED, 0xB0, 0x18, 0xD8, 0xE6,
  0x3F, 0xC6, 0x03, 0x18, 0x07, 0x7E, 0x23, 0xC6,
  0x43, 0x30, 0x01, 0x04, 0x4F, 0xED, 0xA0, 0xE5,
  0x62, 0x6B, 0x2B, 0xED, 0xB0, 0xE1, 0xB7, 0xED,
  0x52, 0x19, 0x20, 0xBB, 0xC9, 0x00, 0x00
};

#define M1_MOVER_LENGTH           sizeof(m1)
#define M1_DEPACK_LENGTH          sizeof(r1)
#define M1_RTN_ADR_SRC_OFFSET     1
#define M1_RTN_ADR_DEST_OFFSET    4
#define M1_DAT_ADR_SRC_OFFSET     13
#define M1_DAT_ADR_DEST_OFFSET    16
#define M1_DAT_LENGTH_OFFSET      19
#define M1_DAT_ADR_TARGET_OFFSET  4
#define M1_JUMP_ADR_OFFSET        76

//---------------------------------------------------------------------------
// mover pre mod 2
BYTE m2[22] = {
  0x21, 0x00, 0x00, 0x11, 0x00, 0x00, 0x01, 0x51,
  0x00, 0xD5, 0xED, 0xB0, 0x21, 0x00, 0x00, 0x11,
  0x00, 0x00, 0x01, 0x00, 0x00, 0xC9
};
// depack rutina pre mod 2
BYTE r2[81] = {
  0xED, 0xB8, 0xEB, 0x11, 0x00, 0x00, 0x23, 0x7E,
  0xCB, 0x7F, 0x20, 0x17, 0xE6, 0x0F, 0xC6, 0x03,
  0x4F, 0xED, 0x6F, 0xE6, 0x07, 0x47, 0x23, 0x7B,
  0x96, 0x23, 0xE5, 0x6F, 0x7A, 0x98, 0x67, 0x06,
  0x00, 0x18, 0x22, 0x23, 0xE6, 0x7F, 0x28, 0x0F,
  0xCB, 0x77, 0x20, 0x05, 0x4F, 0xED, 0xB0, 0x18,
  0xD6, 0xE6, 0x3F, 0xC6, 0x03, 0x18, 0x07, 0x7E,
  0x23, 0xC6, 0x43, 0x30, 0x01, 0x04, 0x4F, 0xED,
  0xA0, 0xE5, 0x62, 0x6B, 0x2B, 0xED, 0xB0, 0xE1,
  0xB7, 0xED, 0x52, 0x19, 0x20, 0xB9, 0xC9, 0x00,
  0x00
};

#define M2_MOVER_LENGTH           sizeof(m2)
#define M2_DEPACK_LENGTH          sizeof(r2)
#define M2_RTN_ADR_SRC_OFFSET     1
#define M2_RTN_ADR_DEST_OFFSET    4
#define M2_DAT_ADR_SRC_OFFSET     13
#define M2_DAT_ADR_DEST_OFFSET    16
#define M2_DAT_LENGTH_OFFSET      19
#define M2_DAT_ADR_TARGET_OFFSET  4
#define M2_JUMP_ADR_OFFSET        78

//---------------------------------------------------------------------------
// mover pre mod 3
BYTE m3[19] = {
  0x21, 0x00, 0x00, 0x11, 0x00, 0x00, 0x01, 0x4F,
  0x00, 0xD5, 0xED, 0xB0, 0x11, 0x00, 0x00, 0x01,
  0x00, 0x00, 0xC9
};
// depack rutina pre mod 3
BYTE r3[79] = {
  0xED, 0xB0, 0xEB, 0x11, 0x00, 0x00, 0x2B, 0x7E,
  0xCB, 0x7F, 0x20, 0x15, 0xE6, 0x0F, 0x47, 0xED,
  0x6F, 0xC6, 0x03, 0x4F, 0x2B, 0x7B, 0x86, 0x2B,
  0xE5, 0x6F, 0x7A, 0x88, 0x67, 0x06, 0x00, 0x18,
  0x22, 0x2B, 0xE6, 0x7F, 0x28, 0x0F, 0xCB, 0x77,
  0x20, 0x05, 0x4F, 0xED, 0xB8, 0x18, 0xD8, 0xE6,
  0x3F, 0xC6, 0x03, 0x18, 0x07, 0x7E, 0x2B, 0xC6,
  0x43, 0x30, 0x01, 0x04, 0x4F, 0xED, 0xA8, 0xE5,
  0x62, 0x6B, 0x23, 0xED, 0xB8, 0xE1, 0xB7, 0xED,
  0x52, 0x19, 0x20, 0xBB, 0xC9, 0x00, 0x00
};

#define M3_MOVER_LENGTH           sizeof(m3)
#define M3_DEPACK_LENGTH          sizeof(r3)
#define M3_RTN_ADR_SRC_OFFSET     1
#define M3_RTN_ADR_DEST_OFFSET    4
#define M3_DAT_ADR_SRC_OFFSET     -1
#define M3_DAT_ADR_DEST_OFFSET    13
#define M3_DAT_LENGTH_OFFSET      16
#define M3_DAT_ADR_TARGET_OFFSET  4
#define M3_JUMP_ADR_OFFSET        76

//---------------------------------------------------------------------------
// mover pre mod 4
BYTE m4[19] = {
  0x21, 0x00, 0x00, 0x11, 0x00, 0x00, 0x01, 0x51,
  0x00, 0xD5, 0xED, 0xB0, 0x11, 0x00, 0x00, 0x01,
  0x00, 0x00, 0xC9
};
// depack rutina pre mod 4
BYTE r4[81] = {
  0xED, 0xB0, 0xEB, 0x11, 0x00, 0x00, 0x2B, 0x7E,
  0xCB, 0x7F, 0x20, 0x17, 0xE6, 0x0F, 0xC6, 0x03,
  0x4F, 0xED, 0x6F, 0xE6, 0x07, 0x47, 0x2B, 0x7B,
  0x86, 0x2B, 0xE5, 0x6F, 0x7A, 0x88, 0x67, 0x06,
  0x00, 0x18, 0x22, 0x2B, 0xE6, 0x7F, 0x28, 0x0F,
  0xCB, 0x77, 0x20, 0x05, 0x4F, 0xED, 0xB8, 0x18,
  0xD6, 0xE6, 0x3F, 0xC6, 0x03, 0x18, 0x07, 0x7E,
  0x2B, 0xC6, 0x43, 0x30, 0x01, 0x04, 0x4F, 0xED,
  0xA8, 0xE5, 0x62, 0x6B, 0x23, 0xED, 0xB8, 0xE1,
  0xB7, 0xED, 0x52, 0x19, 0x20, 0xB9, 0xC9, 0x00,
  0x00
};

#define M4_MOVER_LENGTH           sizeof(m4)
#define M4_DEPACK_LENGTH          sizeof(r4)
#define M4_RTN_ADR_SRC_OFFSET     1
#define M4_RTN_ADR_DEST_OFFSET    4
#define M4_DAT_ADR_SRC_OFFSET     -1
#define M4_DAT_ADR_DEST_OFFSET    13
#define M4_DAT_LENGTH_OFFSET      16
#define M4_DAT_ADR_TARGET_OFFSET  4
#define M4_JUMP_ADR_OFFSET        78

//---------------------------------------------------------------------------
// ridky BASIC loadera
BYTE line10[] = { // 10 REM loader by quido vx.x
  0, 0x0A, 0, 0,
  0xEA, 'L', 'o', 'a', 'd', 'e', 'r', ' ', 'b', 'y', ' ', '$', 0x0D
};
BYTE line20[] = { // 20 BORDER VAL "0": PAPER VAL "0": INK VAL "7"
  0, 0x14, 0, 0,
  0xE7, 0xB0, '"', '#', '"', ':',
  0xDA, 0xB0, '"', '#', '"', ':',
  0xD9, 0xB0, '"', '#', '"', 0x0D
};
BYTE line30[] = { // 30 CLEAR VAL "24575"
  0, 0x1E, 0, 0,
  0xFD, 0xB0, '"', '@', '"', 0x0D
};
BYTE line40[] = { // 40 POKE VAL "23739", CODE "o"
  0, 0x28, 0, 0,
  0xF4, 0xB0, '"', '2', '3', '7', '3', '9', '"', ',' , 0xAF, '"', 'o', '"', 0x0D
};
BYTE line50[] = { // 50 LOAD *"meno_suboru" CODE
  0, 0x32, 0, 0,
  0xEF, '$', '"', '$', '"', 0xAF, 0x0D
};
BYTE line60[] = {
  0, 0x3C, 0, 0,
  0xF9, 0xC0, 0xB0, '"', '@', '"', 0x0D
};

//---------------------------------------------------------------------------
#pragma pack(push,1)
typedef struct {
  BYTE flag;
  BYTE type;
  BYTE name[10];
  WORD length;
  WORD start;
  WORD par3;
  BYTE crc;
} ZXS_TAPE_HEADER;
#pragma pack(pop)

#define TAP_FLAG_HEAD             (BYTE)0x00
#define TAP_FLAG_BODY             (BYTE)0xFF
#define TAP_TYPE_BASIC            (BYTE)0x00
#define TAP_TYPE_CODE             (BYTE)0x03

//---------------------------------------------------------------------------
void calculateChecksumZX(BYTE *buf, int len, BYTE *pcrc)
{
  int ii;
  BYTE crc = *pcrc;
  BYTE *p = buf;

  for (ii = 0 ; ii < len; ii++)
    crc ^= *p++;
  *pcrc = crc;
}
//---------------------------------------------------------------------------
void getRoutinesLengthZ80(WORK_PARAMS *wp)
{
  wp->moverLen[0] = M1_MOVER_LENGTH;
  wp->rtnLen[0] = M1_DEPACK_LENGTH;
  wp->moverLen[1] = M2_MOVER_LENGTH;
  wp->rtnLen[1] = M2_DEPACK_LENGTH;
  wp->moverLen[2] = M3_MOVER_LENGTH;
  wp->rtnLen[2] = M3_DEPACK_LENGTH;
  wp->moverLen[3] = M4_MOVER_LENGTH;
  wp->rtnLen[3] = M4_DEPACK_LENGTH;
}
//---------------------------------------------------------------------------
int prepareRoutineZ80(WORK_PARAMS *wp, BYTE *rtn)
{
  BYTE *m, *r;
  int rtnAdrSrcOff, rtnAdrDestOff, jumpAdrOff;
  int datAdrSrcOff, datAdrDestOff, datLenOff, datAdrTargOff;
  int rtnAdrSrc, rtnAdrDest, jumpAdr;
  int datAdrSrc, datAdrDest, datLen, datAdrTarg;
  int rtnLenM, rtnLenR;

  switch (wp->modeMask) {
    case PACK_MODE_1 :
      rtnAdrSrcOff = M1_RTN_ADR_SRC_OFFSET;
      rtnAdrDestOff = M1_RTN_ADR_DEST_OFFSET;
      datAdrSrcOff = M1_DAT_ADR_SRC_OFFSET;
      datAdrDestOff = M1_DAT_ADR_DEST_OFFSET;
      datLenOff = M1_DAT_LENGTH_OFFSET;
      datAdrTargOff = M1_DAT_ADR_TARGET_OFFSET;
      jumpAdrOff = M1_JUMP_ADR_OFFSET;

      rtnAdrSrc = wp->targetAddr + M1_MOVER_LENGTH;
      rtnAdrDest = wp->unpackRtnAddr;
      datAdrSrc = wp->targetAddr + M1_MOVER_LENGTH + M1_DEPACK_LENGTH + wp->packedLen[wp->mode] - 1;
      datAdrDest = wp->targetAddr + wp->originalLen - 1;
      datLen = wp->packedLen[wp->mode];
      datAdrTarg = wp->targetAddr;
      jumpAdr = wp->jumpAddr;

      m = m1;
      r = r1;
      rtnLenM = M1_MOVER_LENGTH;
      rtnLenR = M1_DEPACK_LENGTH;
      break;

    case PACK_MODE_2 :
      rtnAdrSrcOff = M2_RTN_ADR_SRC_OFFSET;
      rtnAdrDestOff = M2_RTN_ADR_DEST_OFFSET;
      datAdrSrcOff = M2_DAT_ADR_SRC_OFFSET;
      datAdrDestOff = M2_DAT_ADR_DEST_OFFSET;
      datLenOff = M2_DAT_LENGTH_OFFSET;
      datAdrTargOff = M2_DAT_ADR_TARGET_OFFSET;
      jumpAdrOff = M2_JUMP_ADR_OFFSET;

      rtnAdrSrc = wp->targetAddr + M2_MOVER_LENGTH;
      rtnAdrDest = wp->unpackRtnAddr;
      datAdrSrc = wp->targetAddr + M2_MOVER_LENGTH + M2_DEPACK_LENGTH + wp->packedLen[wp->mode] - 1;
      datAdrDest = wp->targetAddr + wp->originalLen - 1;
      datLen = wp->packedLen[wp->mode];
      datAdrTarg = wp->targetAddr;
      jumpAdr = wp->jumpAddr;

      m = m2;
      r = r2;
      rtnLenM = M2_MOVER_LENGTH;
      rtnLenR = M2_DEPACK_LENGTH;
      break;

    case PACK_MODE_3 :
      rtnAdrSrcOff = M3_RTN_ADR_SRC_OFFSET;
      rtnAdrDestOff = M3_RTN_ADR_DEST_OFFSET;
      datAdrSrcOff = M3_DAT_ADR_SRC_OFFSET;
      datAdrDestOff = M3_DAT_ADR_DEST_OFFSET;
      datLenOff = M3_DAT_LENGTH_OFFSET;
      datAdrTargOff = M3_DAT_ADR_TARGET_OFFSET;
      jumpAdrOff = M3_JUMP_ADR_OFFSET;

      rtnAdrSrc = wp->targetAddr + M3_MOVER_LENGTH;
      rtnAdrDest = wp->unpackRtnAddr;
      datAdrSrc = -1;
      datAdrDest = wp->targetAddr;
      datLen = wp->packedLen[wp->mode];
      datAdrTarg = wp->targetAddr + wp->originalLen - 1;
      jumpAdr = wp->jumpAddr;

      m = m3;
      r = r3;
      rtnLenM = M3_MOVER_LENGTH;
      rtnLenR = M3_DEPACK_LENGTH;
      break;

    case PACK_MODE_4 :
      rtnAdrSrcOff = M4_RTN_ADR_SRC_OFFSET;
      rtnAdrDestOff = M4_RTN_ADR_DEST_OFFSET;
      datAdrSrcOff = M4_DAT_ADR_SRC_OFFSET;
      datAdrDestOff = M4_DAT_ADR_DEST_OFFSET;
      datLenOff = M4_DAT_LENGTH_OFFSET;
      datAdrTargOff = M4_DAT_ADR_TARGET_OFFSET;
      jumpAdrOff = M4_JUMP_ADR_OFFSET;

      rtnAdrSrc = wp->targetAddr + M4_MOVER_LENGTH;
      rtnAdrDest = wp->unpackRtnAddr;
      datAdrSrc = -1;
      datAdrDest = wp->targetAddr;
      datLen = wp->packedLen[wp->mode];
      datAdrTarg = wp->targetAddr + wp->originalLen - 1;
      jumpAdr = wp->jumpAddr;

      m = m4;
      r = r4;
      rtnLenM = M4_MOVER_LENGTH;
      rtnLenR = M4_DEPACK_LENGTH;
      break;
  }

  *(WORD *) (m + rtnAdrSrcOff) = (WORD) rtnAdrSrc;
  *(WORD *) (m + rtnAdrDestOff) = (WORD) rtnAdrDest;
  if (datAdrSrcOff >= 0)
    *(WORD *) (m + datAdrSrcOff) = (WORD) datAdrSrc;
  *(WORD *) (m + datAdrDestOff) = (WORD) datAdrDest;
  *(WORD *) (m + datLenOff) = (WORD) datLen;

  *(WORD *) (r + datAdrTargOff) = (WORD) datAdrTarg;
  if (jumpAdr < 0) {
    *(r + jumpAdrOff) = 0xC9; // RET
    *(WORD *) (r + jumpAdrOff + 1) = (WORD) 0;
  }
  else {
    *(r + jumpAdrOff) = 0xC3; // JP adr
    *(WORD *) (r + jumpAdrOff + 1) = (WORD) jumpAdr;
  }

  memcpy(rtn, m, rtnLenM);
  memcpy(rtn + rtnLenM, r, rtnLenR);

  return rtnLenM + rtnLenR;
}
//---------------------------------------------------------------------------
void constructBinZ80(WORK_PARAMS *wp, BYTE **out, BYTE *packed)
{
  int rtnLen;
  BYTE *o, rtn[256];

  if (wp->modeMask == 0)
    rtnLen = 0;
  else
    rtnLen = prepareRoutineZ80(wp, rtn);

  o = *out;
  if (wp->modeMask != 0)
    memcpy(o, rtn, rtnLen);
  memcpy(o + rtnLen, packed, wp->packedLen[wp->mode]);
  o += (rtnLen + wp->packedLen[wp->mode]);
  *out = o;
}
//---------------------------------------------------------------------------
void constructCodeZX(WORK_PARAMS *wp, BYTE **out, BYTE *packed)
{
  ZXS_TAPE_HEADER tap;
  int i, blkLen, rtnLen;
  char *p;
  BYTE *o, crc, rtn[256];

  memset(&tap, 0, sizeof(ZXS_TAPE_HEADER));
  if (wp->modeMask == 0)
    rtnLen = 0;
  else
    rtnLen = prepareRoutineZ80(wp, rtn);
  blkLen = rtnLen + wp->packedLen[wp->mode];

  p = wp->name;
  tap.flag = TAP_FLAG_HEAD;
  for (i = 0; i < 10; i++) {
    if (*p == 0)
      tap.name[i] = ' ';
    else
      tap.name[i] = *p++;
  }

  tap.type = TAP_TYPE_CODE;
  tap.length = (WORD) blkLen;
  tap.start = (WORD) ((wp->targetAddr < 0) ? 32768 : wp->targetAddr);
  tap.par3 = (WORD) wp->originalLen;
  tap.crc = 0;
  calculateChecksumZX(&tap.flag, sizeof(ZXS_TAPE_HEADER) - 1, &tap.crc);

  o = *out;
  *(WORD *) o = (WORD) sizeof(ZXS_TAPE_HEADER);
  o += 2;
  memcpy(o, &tap, sizeof(ZXS_TAPE_HEADER));
  o += sizeof(ZXS_TAPE_HEADER);

  *(WORD *) o = (WORD) (blkLen + 2);
  o += 2;
  *o = TAP_FLAG_BODY;
  if (wp->modeMask != 0)
    memcpy(o + 1, rtn, rtnLen);
  memcpy(o + 1 + rtnLen, packed, wp->packedLen[wp->mode]);
  crc = 0;
  calculateChecksumZX(o, blkLen + 1, &crc);
  o += (blkLen + 1);
  *o++ = crc;

  *out = o;
}
//---------------------------------------------------------------------------
void putBasicLine(BYTE **out, BYTE *line, void *param)
{
  BYTE *o = *out, *l = line, c;
  int parIdx = 0, cnt = 0, i;
  char *str = (char *) param;

  do {
    c = *l++;
    switch (c) {
      case '$' :
        i = sprintf((char *) o, "%s", str);
        o += i;
        str += (i + 1);
        cnt += i;
        break;

      case '#' :
        i = sprintf((char *) o, "%d", ((int *) param)[parIdx++]);
        o += i;
        cnt += i;
        break;

      case '@' :
        i = sprintf((char *) o, "%d", *(int *) param);
        o += i;
        cnt += i;
        break;

      default :
        *o++ = c;
        cnt++;
        break;
    }
  } while (c != 0x0D);

  *(WORD *) (*out + 2) = (WORD) (cnt - 4);
  *out = o;
}
//---------------------------------------------------------------------------
int createBasic(WORK_PARAMS *wp, BYTE *out, char *name)
{
  BYTE *o = out;
  char prg[32];
  int v;

  sprintf(prg, "%s v%d.%d", PROG_NAME, PROG_VERSION / 16, PROG_VERSION % 16);
  putBasicLine(&o, line10, prg);
  putBasicLine(&o, line20, wp->colors);
  v = wp->clearAddr;
  putBasicLine(&o, line30, &v);
  if (wp->hp)
    putBasicLine(&o, line40, NULL);
  putBasicLine(&o, line50, name);
  v = wp->runAddr;
  putBasicLine(&o, line60, &v);
  return o - out;
}
//---------------------------------------------------------------------------
void constructBasicZX(WORK_PARAMS *wp, BYTE **out)
{
  ZXS_TAPE_HEADER tap;
  int i, blkLen;
  char *p, n[16];
  BYTE *o, crc;

  memset(&tap, 0, sizeof(ZXS_TAPE_HEADER));
  p = wp->name;
  for (i = 0; i < 10; i++) {
    if (*p == 0)
      tap.name[i] = ' ';
    else
      tap.name[i] = *p++;
  }

  if (wp->d80) {
    n[0] = '*';
    n[1] = 0;
    strcpy(&n[2], wp->name);
  }
  else {
    n[0] = 0;
    strcpy(&n[1], wp->name);
  }


  o = *out;
  blkLen = createBasic(wp, o + 24, n);
  tap.flag = TAP_FLAG_HEAD;
  tap.type = TAP_TYPE_BASIC;
  tap.length = (WORD) blkLen;
  tap.start = 10;
  tap.par3 = (WORD) blkLen;
  tap.crc = 0;
  calculateChecksumZX(&tap.flag, sizeof(ZXS_TAPE_HEADER) - 1, &tap.crc);

  *(WORD *)o = (WORD) sizeof(ZXS_TAPE_HEADER);
  o += 2;
  memcpy(o, &tap, sizeof(ZXS_TAPE_HEADER));
  o += sizeof(ZXS_TAPE_HEADER);

  *(WORD *) o = (WORD) (blkLen + 2);
  o += 2;
  *o = TAP_FLAG_BODY;
  crc = 0;
  calculateChecksumZX(o, blkLen + 1, &crc);
  o += (blkLen + 1);
  *o++ = crc;

  *out = o;
}
//---------------------------------------------------------------------------

